package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFUser;
import com.sa.ibiz.demo.demo.service.WFUserService;
import com.sa.ibiz.demo.demo.service.dto.WFUserSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfuser")
public class WFUserResource
{
	@Autowired
	private WFUserService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<WFUser> get(@Validated @PathVariable String id){
		WFUser data=new WFUser();
		data.setWfuserid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流用户[get]操作发生错误","WFUser",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFUser> checkKey(@Validated @RequestBody WFUser data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户[checkKey]操作发生错误","WFUser",data.getWfuserid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFUser> update(@Validated @RequestBody WFUser data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户[update]操作发生错误","WFUser",data.getWfuserid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFUser> remove(@Validated @RequestBody WFUser data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户[remove]操作发生错误","WFUser",data.getWfuserid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFUser> getDraft(@Validated @RequestBody WFUser data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户[getDraft]操作发生错误","WFUser","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFUser> create(@Validated @RequestBody WFUser data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流用户[create]操作发生错误","WFUser",data.getWfuserid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFUser>> searchDefaultPage(@Validated @RequestBody WFUserSearchFilter filter){
		Page<WFUser> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFUser>> listDefault(@Validated @RequestBody WFUserSearchFilter filter){
		List<WFUser> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
